// Compiled by ClojureScript 1.9.562 {}
goog.provide('octet.spec.basic');
goog.require('cljs.core');
goog.require('octet.buffer');
goog.require('octet.spec');
octet.spec.basic.primitive_spec = (function octet$spec$basic$primitive_spec(size,readfn,writefn){
if(typeof octet.spec.basic.t_octet$spec$basic34423 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IFn}
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34423 = (function (size,readfn,writefn,meta34424){
this.size = size;
this.readfn = readfn;
this.writefn = writefn;
this.meta34424 = meta34424;
this.cljs$lang$protocol_mask$partition0$ = 393217;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34423.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34425,meta34424__$1){
var self__ = this;
var _34425__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34423(self__.size,self__.readfn,self__.writefn,meta34424__$1));
});

octet.spec.basic.t_octet$spec$basic34423.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34425){
var self__ = this;
var _34425__$1 = this;
return self__.meta34424;
});

octet.spec.basic.t_octet$spec$basic34423.prototype.call = (function (self__){
var self__ = this;
var self____$1 = this;
var s = self____$1;
return s;
});

octet.spec.basic.t_octet$spec$basic34423.prototype.apply = (function (self__,args34426){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args34426)));
});

octet.spec.basic.t_octet$spec$basic34423.prototype.cljs$core$IFn$_invoke$arity$0 = (function (){
var self__ = this;
var s = this;
return s;
});

octet.spec.basic.t_octet$spec$basic34423.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34423.prototype.octet$spec$ISpecSize$size$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.size;
});

octet.spec.basic.t_octet$spec$basic34423.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34423.prototype.octet$spec$ISpec$read$arity$3 = (function (_,buff,pos){
var self__ = this;
var ___$1 = this;
var readed = self__.readfn.call(null,buff,pos);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.size,readed], null);
});

octet.spec.basic.t_octet$spec$basic34423.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
var G__34427_34428 = value;
if((G__34427_34428 == null)){
} else {
self__.writefn.call(null,buff,pos,G__34427_34428);
}

return self__.size;
});

octet.spec.basic.t_octet$spec$basic34423.getBasis = (function (){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.Symbol(null,"readfn","readfn",1394986672,null),new cljs.core.Symbol(null,"writefn","writefn",1052701163,null),new cljs.core.Symbol(null,"meta34424","meta34424",-1213748829,null)], null);
});

octet.spec.basic.t_octet$spec$basic34423.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34423.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34423";

octet.spec.basic.t_octet$spec$basic34423.cljs$lang$ctorPrWriter = (function (this__23995__auto__,writer__23996__auto__,opt__23997__auto__){
return cljs.core._write.call(null,writer__23996__auto__,"octet.spec.basic/t_octet$spec$basic34423");
});

octet.spec.basic.__GT_t_octet$spec$basic34423 = (function octet$spec$basic$primitive_spec_$___GT_t_octet$spec$basic34423(size__$1,readfn__$1,writefn__$1,meta34424){
return (new octet.spec.basic.t_octet$spec$basic34423(size__$1,readfn__$1,writefn__$1,meta34424));
});

}

return (new octet.spec.basic.t_octet$spec$basic34423(size,readfn,writefn,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Boolean type spec.
 */
octet.spec.basic.bool = (function (){
if(typeof octet.spec.basic.t_octet$spec$basic34429 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IFn}
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34429 = (function (meta34430){
this.meta34430 = meta34430;
this.cljs$lang$protocol_mask$partition0$ = 393217;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34429.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34431,meta34430__$1){
var self__ = this;
var _34431__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34429(meta34430__$1));
});

octet.spec.basic.t_octet$spec$basic34429.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34431){
var self__ = this;
var _34431__$1 = this;
return self__.meta34430;
});

octet.spec.basic.t_octet$spec$basic34429.prototype.call = (function (self__){
var self__ = this;
var self____$1 = this;
var s = self____$1;
return s;
});

octet.spec.basic.t_octet$spec$basic34429.prototype.apply = (function (self__,args34432){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args34432)));
});

octet.spec.basic.t_octet$spec$basic34429.prototype.cljs$core$IFn$_invoke$arity$0 = (function (){
var self__ = this;
var s = this;
return s;
});

octet.spec.basic.t_octet$spec$basic34429.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34429.prototype.octet$spec$ISpecSize$size$arity$1 = (function (__SHARP_){
var self__ = this;
var __SHARP___$1 = this;
return (1);
});

octet.spec.basic.t_octet$spec$basic34429.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34429.prototype.octet$spec$ISpec$read$arity$3 = (function (__SHARP_,buff,pos){
var self__ = this;
var __SHARP___$1 = this;
var readed = octet.buffer.read_byte.call(null,buff,pos);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(1),(function (){var pred__34433 = cljs.core._EQ_;
var expr__34434 = readed;
if(cljs.core.truth_(pred__34433.call(null,(0),expr__34434))){
return false;
} else {
if(cljs.core.truth_(pred__34433.call(null,(1),expr__34434))){
return true;
} else {
return null;
}
}
})()], null);
});

octet.spec.basic.t_octet$spec$basic34429.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
var value__$1 = (function (){var pred__34436 = cljs.core._EQ_;
var expr__34437 = value;
if(cljs.core.truth_(pred__34436.call(null,true,expr__34437))){
return (1);
} else {
if(cljs.core.truth_(pred__34436.call(null,false,expr__34437))){
return (0);
} else {
return (-1);
}
}
})();
octet.buffer.write_byte.call(null,buff,pos,value__$1);

return (1);
});

octet.spec.basic.t_octet$spec$basic34429.getBasis = (function (){
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"meta34430","meta34430",721131375,null)], null);
});

octet.spec.basic.t_octet$spec$basic34429.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34429.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34429";

octet.spec.basic.t_octet$spec$basic34429.cljs$lang$ctorPrWriter = (function (this__23995__auto__,writer__23996__auto__,opt__23997__auto__){
return cljs.core._write.call(null,writer__23996__auto__,"octet.spec.basic/t_octet$spec$basic34429");
});

octet.spec.basic.__GT_t_octet$spec$basic34429 = (function octet$spec$basic$__GT_t_octet$spec$basic34429(meta34430){
return (new octet.spec.basic.t_octet$spec$basic34429(meta34430));
});

}

return (new octet.spec.basic.t_octet$spec$basic34429(cljs.core.PersistentArrayMap.EMPTY));
})()
;
/**
 * Byte type spec.
 */
octet.spec.basic.byte$ = octet.spec.basic.primitive_spec.call(null,(1),octet.buffer.read_byte,octet.buffer.write_byte);
/**
 * Short type spec.
 */
octet.spec.basic.int16 = octet.spec.basic.primitive_spec.call(null,(2),octet.buffer.read_short,octet.buffer.write_short);
/**
 * Integer type spec.
 */
octet.spec.basic.int32 = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_int,octet.buffer.write_int);
/**
 * Long type spec.
 */
octet.spec.basic.int64 = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_long,octet.buffer.write_long);
/**
 * Float type spec
 */
octet.spec.basic.float$ = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_float,octet.buffer.write_float);
/**
 * Double type spec.
 */
octet.spec.basic.double$ = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_double,octet.buffer.write_double);
/**
 * Fixed size byte array type spec constructor.
 */
octet.spec.basic.bytes = (function octet$spec$basic$bytes(size){
if(typeof octet.spec.basic.t_octet$spec$basic34442 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {octet.spec.ISpec}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
 * @implements {octet.spec.ISpecSize}
*/
octet.spec.basic.t_octet$spec$basic34442 = (function (size,meta34443){
this.size = size;
this.meta34443 = meta34443;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
octet.spec.basic.t_octet$spec$basic34442.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_34444,meta34443__$1){
var self__ = this;
var _34444__$1 = this;
return (new octet.spec.basic.t_octet$spec$basic34442(self__.size,meta34443__$1));
});

octet.spec.basic.t_octet$spec$basic34442.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_34444){
var self__ = this;
var _34444__$1 = this;
return self__.meta34443;
});

octet.spec.basic.t_octet$spec$basic34442.prototype.octet$spec$ISpecSize$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34442.prototype.octet$spec$ISpecSize$size$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.size;
});

octet.spec.basic.t_octet$spec$basic34442.prototype.octet$spec$ISpec$ = cljs.core.PROTOCOL_SENTINEL;

octet.spec.basic.t_octet$spec$basic34442.prototype.octet$spec$ISpec$read$arity$3 = (function (_,buff,pos){
var self__ = this;
var ___$1 = this;
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.size,octet.buffer.read_bytes.call(null,buff,pos,self__.size)], null);
});

octet.spec.basic.t_octet$spec$basic34442.prototype.octet$spec$ISpec$write$arity$4 = (function (_,buff,pos,value){
var self__ = this;
var ___$1 = this;
octet.buffer.write_bytes.call(null,buff,pos,self__.size,value);

return self__.size;
});

octet.spec.basic.t_octet$spec$basic34442.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.with_meta(new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol(null,"long","long",1469079434,null)], null)),new cljs.core.Symbol(null,"meta34443","meta34443",-951710982,null)], null);
});

octet.spec.basic.t_octet$spec$basic34442.cljs$lang$type = true;

octet.spec.basic.t_octet$spec$basic34442.cljs$lang$ctorStr = "octet.spec.basic/t_octet$spec$basic34442";

octet.spec.basic.t_octet$spec$basic34442.cljs$lang$ctorPrWriter = (function (this__23995__auto__,writer__23996__auto__,opt__23997__auto__){
return cljs.core._write.call(null,writer__23996__auto__,"octet.spec.basic/t_octet$spec$basic34442");
});

octet.spec.basic.__GT_t_octet$spec$basic34442 = (function octet$spec$basic$bytes_$___GT_t_octet$spec$basic34442(size__$1,meta34443){
return (new octet.spec.basic.t_octet$spec$basic34442(size__$1,meta34443));
});

}

return (new octet.spec.basic.t_octet$spec$basic34442(size,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Unsinged int16 type spec.
 */
octet.spec.basic.uint16 = octet.spec.basic.primitive_spec.call(null,(2),octet.buffer.read_ushort,octet.buffer.write_ushort);
/**
 * Unsinged int32 type spec.
 */
octet.spec.basic.uint32 = octet.spec.basic.primitive_spec.call(null,(4),octet.buffer.read_uint,octet.buffer.write_uint);
/**
 * Unsinged byte type spec.
 */
octet.spec.basic.ubyte = octet.spec.basic.primitive_spec.call(null,(1),octet.buffer.read_ubyte,octet.buffer.write_ubyte);
/**
 * Unsinged int64 type spec.
 */
octet.spec.basic.uint64 = octet.spec.basic.primitive_spec.call(null,(8),octet.buffer.read_ulong,octet.buffer.write_ulong);
